# *** Come visit us at the phlatforum.com,if interested in CNC & using Sketchup for modeling & generating gcode ***

# "RepairBL and Phlatten" v1.1  by kyyu
# this plugin was made to help automate some repetitive tasks into one simple operation.
# To use select your parts.  Then his plugin will:
	#1)move the parts 2" up
	#2)apply the repair_broken_lines plugin (which combines colinear lines into one)
		#I've incorporated this plugin with credits.  That's so we don't have multiple undos, like in v1.0  
	#3)apply the Phlatscript Phlatten code.  This give the projection onto the ground plane.
		#Be careful doing this projection on non flat looking or tilted parts, as they can be distorted.
#Changes: move parts 2" up 1st, single undo, no longer need seperate install of repair_broken_lines.rb



def kyyu_repairBL_n_Phlatscript_Phlatten

	Sketchup.active_model.start_operation "kyyu_Begin_RBLnPhlat"

	sel = Sketchup.active_model.selection
	dist = Geom::Point3d.new [0, 0, 2]
	tr = Geom::Transformation.new (dist)
	Sketchup.active_model.entities.transform_entities(tr, sel)
	
	
#repair_broken_lines.rb - Orginal Code - Begin
# (c) Carlo Roosen 2004
#def repair_broken_lines
  model = Sketchup.active_model
  #define everything as one undo operation
  #model.start_operation "Repair Broken Lines"

  trunk = Array.new
  ss = model.selection
  #search all edges in selection set
  for e in ss
    if (e.kind_of?(Sketchup::Edge))
      p=e.parent
      #take both vertices 
      for v in e.vertices 
        #take all edges connected to v (including e)
        es=v.edges
        #when two edges are connected
        if (es.length==2)
          vec1 = es[0].line[1]
          vec2 = es[1].line[1]
          #and both are in the same direction
          if (vec1.parallel?(vec2))
            #then the two lines can be repaired
            #this is done by generating a new line from the vertex to a random point
            l = p.entities.add_line (v.position, Geom::Point3d.new(3.45,6.78,9.12))
            #and put that line in a trunk
            trunk.push(l)
          end
        end
      end
    end
  end

  #erase all lines in trunk
  total = trunk.length
  for l in trunk
    l.erase!
  end
  #model.commit_operation
  UI.messagebox ("#{total} lines repaired")
#end
#repair_broken_lines.rb - Orginal Code - End

	
	#Phlatscript Phlatten Script - Orginal Code - Begin
      # For now this will just project the lines along Z to 0 
      # TODO: Find a plane that intersects the selected edges and transform them to Z0 to keep existing line lengths
      del_edges = []
      new_edges = []
      edges = []
      faces = []
      #Sketchup.active_model.start_operation "Phlattening selected edges", true
      Sketchup.active_model.selection.each { |entity| 
        edges.push(entity) if entity.kind_of?(Sketchup::Edge)  
        entity.erase! if entity.kind_of?(Sketchup::Face)
      }
      Sketchup.active_model.selection.clear

      edges.each { |edge|
        edge.faces.each { |face|
          face.erase! if face.valid?
        }
        pos1 = edge.vertices.first.position
        pos2 = edge.vertices.last.position
        pt1 = Geom::Point3d.new(pos1.x, pos1.y, 0)
        pt2 = Geom::Point3d.new(pos2.x, pos2.y, 0)
        del_edges.push(edge)
        new_edges.push([pt1,pt2])
      }

      Sketchup.active_model.entities.erase_entities del_edges
      new_edges.each { |pts| 
        edges = Sketchup.active_model.entities.add_edges(pts[0], pts[1])
        edges.each { |e| e.find_faces} if edges
      }

      Sketchup.active_model.commit_operation
	  #Phlatscript Phlatten Script - Orginal Code - End
	  
end

       
       plugins_menu = UI.menu("Plugins")
       plugins_menu.add_item("RepairBL and Phlatten") { kyyu_repairBL_n_Phlatscript_Phlatten}
	   


